
var loginType = {fileName:'SDK-DEMO:createDom.js'};
/*Create video, and some related click events*/
function createVideoBlock(id,nickname,isme ,again,mainDevice ) {
    var videoContainer = document.getElementById('videoContainer');
    if (!videoContainer) {
        return;
    }
    var li = document.createElement('li');
    var mainDiv = document.createElement('div');
    var divFirst = document.createElement('div');
    if (isme) {
    } else {
        var divd = document.createElement('div');
        var divdd = document.createElement('div');
    }
    var divLast = document.createElement('div');
    var spanFirst = document.createElement('span');
    var spanLast = document.createElement('span');
    spanLast.innerText = nickname;
    li.setAttribute("extensionId", id);
    spanFirst.id = volStr + id;
    spanFirst.className = 'volspan';
    divLast.appendChild(spanFirst);
    divLast.appendChild(spanLast);
    mainDiv.className = 'videoBlock ';
    mainDiv.id = prefixStr + id;
    divFirst.className = 'iconBlock ';
    divLast.className = 'infoBlock ';
    if (isme) {
        li.setAttribute("isme", 'true');
    } else {
        divd.className = 'btn';
        divdd.className = 'btn-tick ';
    }
    if (isme) {
    } else {
        /* 多流暂时注释 divd.appendChild(divdd);*/
        divFirst.appendChild(divd);
    }
    mainDiv.appendChild(divFirst);
    mainDiv.appendChild(divLast);
    var mainDeviceFlag = document.createElement('div');
    mainDeviceFlag.innerText = 'my main device';
    if (mainDevice) {
        mainDeviceFlag.className = 'flag mainDevice ';
    } else {
        mainDeviceFlag.className = 'flag ';
    }
    li.appendChild(mainDiv);
    li.appendChild(mainDeviceFlag);
    if (isme) {
        var liList = videoContainer.getElementsByTagName('li');
        if (liList && liList.length > 0) {
            videoContainer.insertBefore(li, liList[0]);
        } else {
            videoContainer.appendChild(li);
        }
    } else {
        videoContainer.appendChild(li);
        divd.onclick = function (e) {
            _room.evictUser(findLiDom(e.path).getAttribute('extensionId'))
        }
    }
    ;
    if (again == 1) {
        li.setAttribute("audio", true);
        li.setAttribute("video", true);
    } else if (again == 2) {
        li.setAttribute("audio", false);
        li.setAttribute("video", true);
    } else if (again == 3) {
        li.setAttribute("audio", true);
        li.setAttribute("video", false);
    }
};

/*Take the closest li element*/
function findLiDom(path) {
    for(var i = 0;i<path.length;i++ ){
        if(path[i].tagName === 'LI'){
            return path[i]
        }
    }
};

/*Create groups of elements that toggle resolution, as well as some related events*/
function createSwitch(width,height,Dom ,maxfps,trigger) {
    var array = ['176*144','320*180','320*240','640*480','1280*720','1920*1080'];
    var fakeFindIndex = function (cb, context) {
        let array = this;

        for (let i = 0; i < array.length; i++) {
            const element = array[i];
            if (cb.call(context, element, i, array)) {
                return i
            }
        }
        return -1
    };
    var index = fakeFindIndex.call(array,function(item){
        return eval(item) === width * height
    });
    var SwitchAry = array.slice(0, index+1);
    if(index < 0){
        SwitchAry.unshift(width + '*' + height)
    };
    var mainDiv = document.createElement('div');
    mainDiv.className = 'SwitchBox ';
    mainDiv.id = 'clickSwitchBox';
    SwitchAry.forEach(function(item) {
        var div = document.createElement('div');
        div.innerText = item;
        mainDiv.appendChild(div);
    });
    if(index > 0){
        if(mainDiv.getElementsByTagName('div')[index]){
            mainDiv.getElementsByTagName('div')[index].className = 'active ';
        }
    }else{
        if( mainDiv.getElementsByTagName('div')[0]){
            mainDiv.getElementsByTagName('div')[0].className = 'active ';
        }
    }
    Dom.appendChild(mainDiv);
    mainDiv.onclick = function (e) {
        if(e.target.parentNode.id === 'clickSwitchBox'){
            var reg=/^([\s\S]+)\*([\s\S]+)/;
            var size = reg.exec(e.target.innerText);
            if(size){
                TK.DeviceMgr.getDevices(function (res) {
                    videolist = res.devices.videoinput;
                    videolist.forEach(function (item, index) {
                        _room.setVideoProfile({width:Number(size[1]),height:Number(size[2]),maxfps:Number(maxfps)},null,item.deviceId);
                    });
                })
                var allBox = mainDiv.getElementsByTagName('div');
                for(var i = 0;i<allBox.length;i++){
                    allBox[i].className=''
                }
                e.target.className = 'active ';
                mainDiv.style.display='none';
            }
        }
    };

    trigger.onclick = function (e) {
        if(getComputedStyle(mainDiv).display === 'none'){
            mainDiv.style.display='block';
        }else{
            mainDiv.style.display='none';
        }
    };
};

/* Delete dom Method */
function removeAllLi(target) {
    var liList = videoContainer.getElementsByTagName('li');
    for(var i = 0;i<liList.length;i++){
        videoContainer.removeChild(liList[i])
    }
};

/* It create three action buttons Method */
function createButtons(ele,sizeObj,triggerEle) {
    if(sizeObj){
        createSwitch(sizeObj.width,sizeObj.height,ele,sizeObj.fps,triggerEle);
    }
};

/* It create user list Method */
function createUserLi(userid,name) {
    var ul = document.getElementById('user-list');
    var li = document.createElement('li');
    var diva = document.createElement('div');
    var divb = document.createElement('div');
    diva.innerText = name;
    diva.title = name;
    diva.className = 'first ';
    divb.id = userid + 'device';
    divb.className = 'last ';
    li.id = userid;
    li.className = 'userItem ';
    li.appendChild(diva);
    li.appendChild(divb);
    ul.appendChild(li);
};

/* It Delete user Method */
function removeUserli(userid,isAll) {
    var ul = document.getElementById('user-list');
    if (!ul) {
        TK.Logger.error(loginType,'Delete user Method error ');
        return
    }
    if (isAll) {
        var clickSwitchBox = document.getElementById('clickSwitchBox');
        var liList = ul.getElementsByTagName('li');
        for (var i = liList.length-1; i > -1; i--) {
            ul.removeChild(liList[i]);
        }
        ul.parentNode.style.display = 'none';
        clickSwitchBox.style.display = 'none';
    } else {
        var cur = document.getElementById(userid);
        ul.removeChild(cur);
    }
};

/*It  Additional video/audio btn method*/
function additionalDom(targetid,adddeviceid,isaudio,isMe,isEvictBtnid) {
    var target = document.getElementById(targetid);
    if(!target){ TK.Logger.error(loginType, 'Additional video/audio btn method error '); return}
    var divlist = target.getElementsByTagName('div');
    if(isEvictBtnid){
        var Btn = document.createElement('div');
        var Btnspan = document.createElement('span');
        Btnspan.id = 'evic' + isEvictBtnid;
        Btnspan.className = 'evict-span';
        Btn.className = 'evict-span';
        Btn.setAttribute('id',isEvictBtnid);
        Btn.appendChild(Btnspan);
        if(divlist && divlist.length > 0){
            target.insertBefore(Btn,divlist[0]);
        }else{
            target.appendChild(Btn);
        }
        Btn.onclick = function () {
            _room ? _room.evictUser(isEvictBtnid ) :null;
        }
    }else{
        if(isaudio){
            var divaudio = document.createElement('div');
            var divaudiospan = document.createElement('span');
            divaudio.id = adddeviceid;
            divaudio.setAttribute("open",'true');
            divaudio.appendChild(divaudiospan);
            divaudiospan.className ='audio-span';
            target.appendChild(divaudio);
            if(divlist && divlist.length > 1){
                if(divlist[0].className && divlist[0].className === 'evict-span'){
                    target.insertBefore(divaudio,divlist[1]);
                }else{
                    target.insertBefore(divaudio,divlist[0]);
                }
            }else{
                target.appendChild(divaudio);
            }
            target.setAttribute("hasAudioBtn",'1');
        }else{
            var diva = document.createElement('div');
            var divaa = document.createElement('span');
            divaa.className = 'video-span';
            diva.id = adddeviceid;
            diva.setAttribute("open",'true');
            diva.appendChild(divaa);
            if(isMe && divlist && divlist.length ){
                if(target.getAttribute("hasAudioBtn") === '1'){
                    target.insertBefore(diva,divlist[1]);
                }else{
                    target.insertBefore(diva,divlist[0]);
                }
            }else{
                target.appendChild(diva);
            }
        }
    }
};

/*It  delete video/audio btn method */
function delAdditionalDom(targetid,deviceid) {
    var target = document.getElementById(targetid);
    if(!target){ TK.Logger.error(loginType, 'delAdditionalDom method error '); return}
    var divlist = target.getElementsByTagName('div');
    for(var i=0;i<divlist.length;i++){
        if(divlist[i].id === deviceid){
            target.removeChild(divlist[i]);
        }
    }
};

 /*It Toggle video/audio status method */
function changeBtnStats(userid,deviceid,flag ,options,isaudio ,islocal) {
    // islocal variable Prevent multiple programs from running at one end.
    var deviceBtn = isaudio ? document.getElementById(userid + 'audio') : (islocal ? document.getElementById(deviceid + 'local' + userid) : document.getElementById(deviceid));
    if (!deviceBtn) {
        TK.Logger.error(loginType, 'changeBtnStats method error ');
        return
    }
    if (userid !== _room.getMySelf().id) {
        if (flag) {
            deviceBtn.className = '';
            if (isaudio) {
                _room ? _room.playAudio(userid) : null;
            } else {
                if (!document.getElementById(prefixStr + deviceid + userid)) {
                    createVideoBlock(deviceid + userid, _room.getUser(userid).nickname, true, 2, _room.getUser(_room.getMySelf().id).tk_maincamera == deviceid);
                }
                if (deviceid == 'undefined' || !deviceid) {
                    _room ? _room.playVideo(userid, prefixStr + deviceid + userid, options, null) : null;
                } else {
                    _room ? _room.playVideo(userid, prefixStr + deviceid + userid, options, null, deviceid) : null;
                }
            }
        } else {
            deviceBtn.className = 'close ';
            if (isaudio) {
                _room ? _room.unplayAudio(userid) : null;
            } else {
                if (deviceid == 'undefined' || !deviceid) {
                    _room ? _room.unplayVideo(userid, function (err) {
                        TK.Logger.error(loginType, 'unplayVideo method error :' + err);
                    }) : null;
                } else {
                    _room ? _room.unplayVideo(userid, function (err) {
                        TK.Logger.error(loginType, 'unplayVideo method error :' + err);
                    }, deviceid) : null;
                }
            }
        }
    }else {
        if (flag) {
            deviceBtn.className = '';
        } else {
            deviceBtn.className = 'close ';
        }
    }
    //document.getElementById('user-list-outer').style.display = 'none';
};

window.createVideoBlock = createVideoBlock;
window.findLiDom = findLiDom;
window.createSwitch =  createSwitch;
window.removeAllLi = removeAllLi;
window.createButtons = createButtons;
window.createUserLi = createUserLi;
window.removeUserli = removeUserli;
window.delAdditionalDom = delAdditionalDom;
window.changeBtnStats = changeBtnStats;
window.additionalDom = additionalDom;